#!/usr/local/bin/perl
#### ȥåХå tbsend.pl V4.00 
#### Copyright 1998-2005 GORRY. 
#### mailto: gorry@hauN.org 
#### 
#### History: 
#### 2005/04/22 V4.00  

require "libgns.pl";
require 'tbsend.ph';

$AGENT = "tbsend.pl";

{
	eval {
		&main();
	};
}
1;

####################################################################

sub main {
	&Setup_KEEPDIR();

	# 
	$argc = $#ARGV+1;
	if ( $argc != 5 ) {
	    die "Required 5 arguments [year month day titleno Trackback-URL].";
	}
	$year = $ARGV[0]+0;
	$month = $ARGV[1]+0;
	$day = $ARGV[2]+0;
	$tbtitleno = $ARGV[3]+0;
	$url = $ARGV[4];

	# å
	if ( $tbtitleno <= 0 ) {
		&err_tbtitleno();
		exit;
	}
	if ( $url !~ /^http:\/\// ) {
		&err_badurl();
		exit;
	}

	# Υƥ򤹤뤳ȤǡȥåХåѥǡ
	if ( $year == 0 ) {
		&err_datemiss();
		exit;
	}
	if ( ($month < 1) || ($month > 12) ) {
		&err_datemiss();
		exit;
	}
	if ( ($day < 1) || ($day > 31) ) {
		&err_datemiss();
		exit;
	}
	if ( $year >= 1980 ) {
		system( "$PERLCMD mkd.pl $year $month $day test" );
	}

	# ȥåХåѥǡ
	$cmd = $NKFCMD . ' -e ' . $TMPDIR . $SLASH . 'tblist.txt |';
	open( FIN, $cmd );
	for ( $i=0; $i<$tbtitleno; $i++ ) {
		if ( !($tbtitle = <FIN>) ) {
			&err_tbtitleno();
			exit;
		}
		if ( !($tbexcerpt = <FIN>) ) {
			&err_tbtitleno();
			exit;
		}
		if ( !($tburl = <FIN>) ) {
			&err_tbtitleno();
			exit;
		}
	}
	close( FIN );
	$tbtitle =~ s/[\015\012]+//g;
	$tbexcerpt =~ s/[\015\012]+//g;
	$tburl =~ s/[\015\012]+//g;
	$tbtitle = &Encode2URL( $tbtitle, "UTF8" );
	$tbexcerpt = &Encode2URL( $tbexcerpt, "UTF8" );
	$tburl = &Encode2URL( $tburl, "UTF8" );
	$tbcharset = "utf-8";
	$diarytitle = &Encode2URL( $DIARY_TITLE, "UTF8" );

	# HTTPꥯȯ
	$option = "";
	$option .= "User-Agent: $AGENT\n";
#	$option .= "Referer: $URLBASENAME$DIGESTNAME\n";
#	$option .= "Pragma: no-cache\n";
	$option .= "Content-Type: application/x-www-form-urlencoded\n";
	$request = "title=$tbtitle&excerpt=$tbexcerpt&url=$tburl&blog_name=$diarytitle&charset=$tbcharset\n";
	$fout = $TMPDIR . $SLASH . 'tbresult.txt';
	$umaskback = umask( oct($DIARY_TMP_PERM) ^ 0666 );
	( $ret, $sendstr ) = &SendRequestHTTP( $url, "POST", $fout, $request, $option );
	umask( $umaskback );
# print "SendRequestHTTP( $url, POST, $fout, $request, $option ) = $ret\n";
	if ( $ret < 0 ) {
		&err_tbresult( $ret, $url, $sendstr );
		exit;
	}

	# ꥶȲ
	$tbresult = "";
	$fin = $TMPDIR . $SLASH . 'tbresult.txt';
	open( FIN, $fin );
	$line = <FIN>;
# print $line;
	if ( $line =~ m:^[^ ]+ ([0-9]+): ) {
		$result = $1;
# print "HTTP Result: $result\n";
		$result += 0;
		if ( $result != 200 ) {
			&err_tbresult( $result, $url, $sendstr );
			exit;
		}
	} else {
		&err_tbresult( -100, $url, $sendstr );
		exit;
	}
# print "HTTP Result:\n";
# print "> $line";
	while ( $line = <FIN> ) {
# print "> $line";
		$line =~ s/[\015\012]+//g;
		last if ( $line eq "" );
	}
	while ( $line = <FIN> ) {
# print "> $line";
		$line =~ s/[\015\012]+//g;
		$tbresult .= $line;
	}
	close( FIN );
	if ( $tbresult =~ m:<error>[\t ]*([01])[\t ]*</error>: ) {
		$result = $1+0;
		if ( $result != 0 ) {
			$result = -100-$result;
		}
	} else {
		$result = -100;
	}
	if ( $result < 0 ) {
		&err_tbresult( $result, $url, $sendstr );
		exit;
	}

	$err_exit = 0;
}

########################################################################
### HTTPꥯ 
## SUCCESS = SendRequestHTTP( HREF, METHOD, SAVEAS, REQUEST, OPTION )
#
sub SendRequestHTTP
{
	local( $href ) = shift;
	local( $method ) = shift;
	local( $saveas ) = shift;
	local( $request ) = shift;
	local( $option ) = shift;
	local( $lmdate );
	local( $server );
	local( $port );
	local( $path );
	local( $host );
	local( $sendlen );
	local( $sendstr );
	local( $name, $aliases, $type, $len, $thataddr );
	local( $that );
	local( $proto );
	local( $oldselect );
	local( $gettime );
	local( $readbuf );
	local( $readlength );
	local( $contentlength );
	local( $data );
	local( $isbody ) = 0;
	local( $readimagesize ) = 0;
	local( $contenttype );
	local( $readlines ) = 0;
	local( $readbufsize ) = 1024*4;

	$path = $href;
	if ( $PROXY ne "" ) {
		$server = $PROXY;
		$server =~ s/:.*//;
		$port = $PROXY;
		$port =~ s/.*://;
		$path = $href;
		$host = $href;
		$host =~ s%http://([^/:]+).*$%$1%;
	} else {
		$server = $href;
		$server =~ s%http://([^/:]+).*$%$1%;
		$port = $href;
		$port =~ s%http://[^:/]+:%%;
		$port =~ s%^([^/]*).*$%$1%;
		if ( $port == 0 ) {
			$port = 80;
		}
		$path =~ s%http://[^/]+%%;
		$host = $server;
	}
# print "server = $server\n";
# print "port = $port\n";
# print "path = $path\n";
# print "host = $host\n";

	$sendlen = length( $request );
	$sendstr = "$method $path HTTP/1.1\n";
	$sendstr .= "Host: $host\n";
	$sendstr .= "Content-Length: $sendlen\n";
	$sendstr .= "$option";
	$sendstr .= "\n";
	$sendstr .= $request;
# print "sendstr = $sendstr\n";

	if ( $server =~ /^(\d{1,3})[.](\d{1,3})[.](\d{1,3})[.](\d{1,3})$/ ) {
		$thataddr = pack( 'C4', $1, $2, $3, $4 );
	} else {
		( $name, $aliases, $type, $len, $thataddr ) = gethostbyname( $server );
	}

	$that = pack( $SOCKADDR, $AF_INET, $port, $thataddr );
	( $name, $aliases, $proto ) = getprotobyname( 'tcp' );

	eval {
		$SIG{'ALRM'} = 'timeout';
		sub timeout { die "timeout"; }
		eval {
			alarm( $HTTP_TIMEOUT );
		};
		if ( !socket( S, $AF_INET, $SOCK_STREAM, $proto ) ) {
			die "socket error";
		}
		if ( !connect( S, $that ) ) {
			die "connect error";
		}

		$oldselect = select;
		select ( S );
		$| = 1;
		print S "$sendstr";
		select ( $oldselect );

		$contentlength = 0;
		open( SAVEAS, ">$saveas" );
		while (<S>) {
			s/[\015\012]+//g;
			if ( $_ eq '' ) {
				print SAVEAS "\n";
				last;
			}
			if ( $_ =~ /^Content-Length:[ \t]+(\d+)/i ) {
				$contentlength = $1;
			}
			if ( $_ =~ /^Content-Type:[ \t]+(.*)$/i ) {
				$contenttype = $1;
			}
			print SAVEAS "$_\n";
		}
		close( SAVEAS );
		if ( ($contentlength > 0) && (($method eq "PUT") || ($method eq "GET")) ) {
			binmode( SAVEAS );
			binmode( S );
			while ($contentlength) {
				$readlength = $contentlength;
				$readlength = $readbufsize if ($readlength > $readbufsize);
				$readlength = read( S, $readbuf, $readlength );
				last if ( $readlength == 0 );
				syswrite( SAVEAS, $readbuf, $readlength );
				$contentlength -= $readlength;
			}
			close(SAVEAS);
		} else {
			open( SAVEAS, ">>$saveas" );
			while (<S>) {
				print SAVEAS "$_";
				$readlines++;
			}
			close(SAVEAS);
		}
		close(S);
		eval {
			alarm( 0 );
		};
	};

	if ( $@ ne "" ) {
		close(S);
		close(SAVEAS);

		return (-1, $sendstr) if ( $@ =~ "timeout" );
		return (-2, $sendstr);
	}

	return (0, $sendstr);
}

########################################################################

sub err_tbtitleno {
	print <<message;
ȥåХåȥֹ椬ޤ($tbtitleno)
message
}

sub err_badurl {
	print <<message;
ȥåХåURLꤷƤ($url)
message
}

sub err_datemiss {
	print <<message;
դꤷƤ($year $month $day)
message
}

sub err_tbresult {
	local( $ret, $url, $sendstr ) = @_;
	if ( $ret == -1 ) {
		$mes = "ॢ";
	} elsif ( $ret == -2 ) {
		$mes = "̿۾";
	} elsif ( $ret == -100 ) {
		$mes = "ȥåХå褫Τʤ";
	} elsif ( $ret == -101 ) {
		$mes = "ȥåХå褫Υ顼";
	} elsif ( $ret > 0 ) {
		$mes = "HTTPꥶȥɤ򻲾ȤƤ";
	} else {
		$mes = "¾Υ顼";
	}

	print <<message;
========[START OF RESULT]========
ȥåХåǥ顼ȯޤ($ret/$mes)
========[URL]========
$url
========[SEND]========
$sendstr
========[RECEIVE]========
message

	$fin = $TMPDIR . $SLASH . 'tbresult.txt';
	open( FIN, $fin );
	for ( <FIN> ) {
		print;
	}
	print <<message;
========[END OF RESULT]========
message
}


####################################################################

# [EOF]
